﻿using GrapeCity.ActiveReports;
using GrapeCity.ActiveReports.Document;
using GrapeCity.ActiveReports.PageReportModel;
using GrapeCity.Viewer.Common.Model.Interactivity;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication4
{
    public partial class Form1 : Form
    {
        string reportName;
        public Form1()
        {
            InitializeComponent();
            GrapeCity.ActiveReports.PageReport rpt = new GrapeCity.ActiveReports.PageReport(new System.IO.FileInfo(@"..\..\RdlReport1.rdlx"));
            GrapeCity.ActiveReports.Document.PageDocument rptd = new GrapeCity.ActiveReports.Document.PageDocument(rpt);
            this.viewer1.LoadDocument(rptd);


           

          



            this.viewer1.LocateDataSource += Viewer1_LocateDataSource1;

            this.textBox1.Text = reportName;

        }

        private void Viewer1_LocateDataSource1(object sender, GrapeCity.ActiveReports.LocateDataSourceEventArgs args)
        {
            DataTable dt = new DataTable();

            dt.Columns.Add("Field1");
            dt.Columns.Add("Field2");
            dt.Columns.Add("Field3");

            dt.Rows.Add("1", "2", "3");
            dt.Rows.Add("2", "2", "3");
            dt.Rows.Add("3", "2", "3");

            PageReport rp = args.Report.PageReport;

            var text = args.Report.PageReport.Report.Body.ReportItems[0] as GrapeCity.ActiveReports.PageReportModel.TextBox;
       
            reportName = text.Value.ToString();
          
           
            if (args.DataSourceName == "DataSource1")
            {
                if (args.DataSetName == "DataSet1")
                {
                    args.Data = dt;
                }
            }
        }

       

        private void viewer1_Action(object sender, GrapeCity.ActiveReports.Viewer.Win.Viewer.ActionEventArgs e)
        {

            DrillthroughAction act = e.Action as DrillthroughAction;
            var rpt = act.TargetReport;
            var docProp = rpt.GetType().GetProperty("Document", BindingFlags.Instance | BindingFlags.NonPublic);
            var doc = (PageDocument)docProp.GetValue(rpt,null);
            this.textBox1.Text = doc.PageReport.Report.Name;

        }

        private void viewer1_LoadCompleted(object sender, EventArgs e)
        {
           
        }
    }
}
